#!/usr/bin/env python
# -*- coding:utf-8 -*-


# ############################################################################
#  license :
# ============================================================================
#
#  File :        KepcoBOP.py
#
#  Project :     KepcoBOP
#
# This file is part of Tango device class.
#
# Tango is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Tango is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Tango.  If not, see <http://www.gnu.org/licenses/>.
#
#
#  $Author :      jmoldes$
#
#  $Revision :    $
#
#  $Date :        $
#
#  $HeadUrl :     $
# ============================================================================
#            This file is generated by POGO
#     (Program Obviously used to Generate tango Object)
# ############################################################################


import PyTango
import sys
# Add additional import
# ----- PROTECTED REGION ID(KepcoBOP.additionnal_import) ENABLED START -----#
import serial

__all__ = ["KepcoBOP", "KepcoBOPClass", "main"]

__docformat__ = 'restructuredtext'
# ----- PROTECTED REGION END -----#  //  KepcoBOP.additionnal_import

# Device States Description
# ON : Power supply OK and delivering power
# OFF : Power supply OK but in standby mode
# FAULT : Some kind of error detected


class KepcoBOP (PyTango.Device_4Impl):
    """Kepco Bipolar Operational Power supply device server"""

    # -------- Add you global variables here --------------------------
    # ---- PROTECTED REGION ID(KepcoBOP.global_variables) ENABLED START -----#

    KNOWN_SERIAL_CLASSES = ['Serial', 'PySerial']
    SERIAL_TIMEOUT = 5
    TERMINATOR = '\r'
    MODES = {
        '0':   'VOLT',
        '1':   'CURR',
        '1,E': 'EXT'
    }
    XON_XOFF = ('\x11', '\x13')

    def communicate_TTY(self, cmd, output_expected=False):
        """Communication with hardware is direct throught serial port"""
        try:
            self.debug_stream('In %s::communicate_TTY() command input: %s'
                              % (self.__class__.__name__, cmd))
            self.serial.write(cmd+self.TERMINATOR)
            read_ = self.serial.readline()  # it always returns at leat \r\n
            if output_expected:
                output = read_.strip()
                if (len(read_) == 0) or (read_[-1] != self.TERMINATOR):
                    msg = 'In %s::communicate_TTY() no newline detected ('\
                        'possible timeout while reading from serial) got: %s'\
                        % (self.__class__.__name__, repr(read_))
                    self.error_stream(msg)
                    self._set_state(PyTango.DevState.FAULT, msg)
                self.debug_stream('In %s::communicate_TTY() command output: %r'
                                  ' Return value: %r' %
                                  (self.__class__.__name__, read_, output))
                return output
            else:
                return ''
        except serial.SerialTimeoutException:
            self.error_stream('In %s::communicate_TTY() timeout while writting'
                              ' command %s' %
                              (self.__class__.__name__, repr(cmd)))
            raise
        except Exception as e:
            self.error_stream('In %s::communicate_TTY() exception: %s' %
                              (self.__class__.__name__, str(e)))
            raise

    def communicate_Serial(self, cmd, output_expected=False):
        """Communication with hardware is performed through a Serial tango
        device server
        VERY IMPORTANT!!!!: note that Serial device server doesn't support
        XON/XOFF (software flow control)
        """
        try:
            self.debug_stream('In %s::communicate_Serial() command input: %s'
                              % (self.__class__.__name__, cmd))
            self.serial.command_inout('DevSerWriteString', cmd+self.TERMINATOR)
            # at least \r\n is always returned
            read_ = self.serial.command_inout('DevSerReadLine')
            if output_expected:
                output = read_.strip()
                if not self.flow_control:
                    # preserve all characters except xon and xoff
                    output = [x for x in output if x not in self.XON_XOFF]
                if (len(read_) == 0) or (read_[-1] != self.TERMINATOR):
                    msg = 'In %s::communicate_Serial() no newline detected ('\
                          'timeout while reading from serial) got: %s' %\
                          (self.__class__.__name__, repr(read_))
                    self.error_stream(msg)
                    self._set_state(PyTango.DevState.FAULT, msg)
                self.debug_stream('In %s::communicate_Serial() command output:'
                                  ' %r Return value: %r' %
                                  (self.__class__.__name__, read_, output))
                return output
            else:
                return ''
        except Exception as e:
            self.error_stream('In %s::communicate_Serial() exception: %s'
                              % (self.__class__.__name__, str(e)))
            raise

    def communicate_PySerial(self, cmd, output_expected=False):
        try:
            self.debug_stream('In %s::communicate_PySerial() cmd input: %s'
                              % (self.__class__.__name__, cmd))
            self.serial.command_inout('Write', bytearray(cmd+self.TERMINATOR))
            # at least \r\n is always returned
            read_ = self.serial.command_inout('ReadLine')
            if output_expected:
                read_ = read_.tostring()
                if (len(read_) == 0) or (read_[-1] != self.TERMINATOR):
                    msg = 'In %s::communicate_PySerial() no newline detected '\
                          '(timeout while reading from serial) got: %s'\
                          % (self.__class__.__name__, repr(read_))
                    self.error_stream(msg)
                    self._set_state(PyTango.DevState.FAULT, msg)
                output = read_.strip()
                if len(output) == 0:
                    msg = 'Got empty output from PySerial device. This is '\
                          'probably a communication error. Please check. '\
                          'Got from PySerial: %s' % repr(read_)
                    self.error_stream(msg)
                    PyTango.Except.throw_exception(
                        'Communication error',
                        msg,
                        '%s::communicate_PySerial()' % self.__class__.__name__)
                self.debug_stream(
                    'In %s::communicate_PySerial() command '
                    'output: %r Return value: %r' %
                    (self.__class__.__name__, read_, output))
                return output
            else:
                return ''
        except Exception as e:
            self.error_stream(
                'In %s::communicate_PySerial() unexpected exception: %s'
                % (self.__class__.__name__, str(e)))
            raise

    def communicate(self, cmd, output_expected=False):

            self.debug_stream("In %s::communicate() input is: %r" %
                              (self.__class__.__name__, cmd))
            transient_errors = 0
            # Hardware sometimes responds with empty string to valid requests:
            # this has been reported to manufacturer but got no answer so far:
            # by now all we can do is simply retry
            while transient_errors <= self.MaxRetries:
                output = ''
                try:
                    output = self.communicate_raw(cmd, output_expected)
                    if output_expected and output == '':
                        msg = "In %s::communicate() output TRANSIENT ERROR "\
                              "DETECTED!!!" % (self.__class__.__name__)
                        self.error_stream(msg)
                        transient_errors += 1
                    else:
                        self.debug_stream(
                            "In %s::communicate() output is: %r"
                            % (self.__class__.__name__, repr(output)))
                        return output
                except Exception as e:
                    msg = 'Error while communicating: %s' % str(e)
                    self.error_stream(msg)
                    transient_errors += 1
                if transient_errors > self.MaxRetries:
                    msg = 'Unable to communicate with instrument'
                    self.error_stream(msg)
                    self._set_state(PyTango.DevState.FAULT, msg)
                    break

    def init_comms(self):
        # check if requesting direct access to serial port
        try:
            self.serial = serial.Serial(
                port=self.SerialDevice,
                baudrate=9600,
                bytesize=serial.EIGHTBITS,
                parity=serial.PARITY_NONE,
                stopbits=serial.STOPBITS_ONE,
                timeout=self.SERIAL_TIMEOUT,
                xonxoff=self.flow_control,
                rtscts=0,
                interCharTimeout=None
            )
            self.serial.flush()
            self.communicate_raw = self.communicate_TTY
            return
        except serial.SerialException:
            pass  # maybe not a system serial device: try below tango serial

        # if we reached this point, then communication probably is through a
        # Serial or PySerial device server
        self.serial = PyTango.DeviceProxy(self.SerialDevice)
        self.serial.set_timeout_millis(2000)
        serial_class = self.serial.info().dev_class
        if serial_class not in self.KNOWN_SERIAL_CLASSES:
            msg = 'Unknown serial class %s. Valid ones are: %s' %\
                  (serial_class, self.KNOWN_SERIAL_CLASSES)
            self.error_stream(msg)
            PyTango.Except.throw_exception(
                'Unknown serial class',
                msg,
                '%s::__init__()' % self.__class__.__name__)
        if serial_class == 'Serial':
            self.serial.command_inout('DevSerFlush', 2)
            self.communicate_raw = self.communicate_Serial
            if self.flow_control:
                msg = 'WARNING!!!!: Serial device server does not support '\
                      'XON/XOFF: will ignore flow control chars'
                self.warn_stream(msg)
        elif serial_class == 'PySerial':
            if self.serial.State() == PyTango.DevState.ON:
                self.serial.command_inout('Close')
            if self.flow_control:
                self.serial.write_attribute('FlowControl', 'software')
            else:
                self.serial.write_attribute('FlowControl', 'none')
            if self.serial.State() != PyTango.DevState.ON:
                self.serial.command_inout('Open')
            self.serial.command_inout('FlushInput')
            self.serial.command_inout('FlushOutput')
            self.communicate_raw = self.communicate_PySerial
        else:  # should be impossible, but you never know
            msg = 'Unsupported serial device class: %s. Valid ones are: %s' %\
                (serial_class, str(self.KNOWN_SERIAL_CLASSES))
            self.error_stream(msg)
            PyTango.Except.throw_exception(
                'Communication init error',
                msg,
                '%s::__init__()' % self.__class__.__name__)

        # try a neutral communication just to check
        if self.communicate("*IDN?", output_expected=True) is None:
            raise Exception('Unable to communicate with instrument')

    def attr_allowed_default(self, req_type=None):
        if self.get_state() in [PyTango.DevState.FAULT]:
            return False
        return True

    def _set_state(self, new_state, new_status=None, force_init=False):
        # preserve FAULT state if set
        if self.get_state() == PyTango.DevState.FAULT and not force_init:
            return
        self.set_state(new_state)
        if new_status is not None:
            self.set_status(new_status)
    # ----- PROTECTED REGION END -----#  //  KepcoBOP.global_variables

    def __init__(self, cl, name):
        PyTango.Device_4Impl.__init__(self, cl, name)
        self.debug_stream("In __init__()")
        KepcoBOP.init_device(self)
        # ----- PROTECTED REGION ID(KepcoBOP.__init__) ENABLED START -----#
        for attr_name in KepcoBOPClass.attr_list:
            method = "is_" + attr_name + "_allowed"
            if not hasattr(self.__class__, method):
                setattr(self.__class__, method, self.attr_allowed_default)
        # ----- PROTECTED REGION END -----#  //  KepcoBOP.__init__

    def delete_device(self):
        self.debug_stream("In delete_device()")
        # ---- PROTECTED REGION ID(KepcoBOP.delete_device) ENABLED START -----#
        if type(self.serial) == serial.Serial:
            self.serial.close()
            return
        serial_class = self.serial.info().dev_class
        if serial_class == 'PySerial':
            if serial.state() != PyTango.DevState.OFF:
                serial.command_inout('Close')
        # ----- PROTECTED REGION END -----#  //  KepcoBOP.delete_device

    def init_device(self):
        self.debug_stream("In init_device()")
        self.get_device_properties(self.get_device_class())
        self.attr_Current_read = 0.0
        self.attr_CurrentSetpoint_read = 0.0
        self.attr_FlowControl_read = False
        self.attr_Mode_read = ""
        self.attr_Remote_read = False
        self.attr_Voltage_read = 0.0
        self.attr_VoltageSetpoint_read = 0.0
        self.attr_Output_read = False
        # ----- PROTECTED REGION ID(KepcoBOP.init_device) ENABLED START -----#
        try:
            self.flow_control = False
            self.init_comms()
            self.communicate('*CLS')
            flow_control = self.communicate(':SYST:COMM:SER:PACE?', True)
            if flow_control == 'NONE':
                self.flow_control = False
            elif flow_control == 'XON':
                self.flow_control = True
            else:
                msg = 'Unexpected flow control value: %s' % str(flow_control)
                self.error_stream(msg)
                raise Exception(msg)
            # once we know how the hardware flow control is really configured,
            # then reconfigure communications
            self.init_comms()
            # do an initial reading of current and voltage setpoints
            curr, volt = (self.communicate(':CURR?;VOLT?', True)).split(';')
            self.attr_CurrentSetpoint_read = float(curr)
            self.attr_Voltage_read = float(volt)
            # find out if output is enabled
            output = bool(int(self.communicate(':OUTP?', True)))
            if output:
                state_ = PyTango.DevState.ON
            else:
                state_ = PyTango.DevState.OFF
        except PyTango.DevFailed as e:
            self._set_state(PyTango.DevState.FAULT, str(e[0].desc), True)
        except Exception as e:
            self._set_state(PyTango.DevState.FAULT, str(e), True)
        else:
            self._set_state(state_, 'System is alive', True)
        # ----- PROTECTED REGION END -----#  //  KepcoBOP.init_device

    def always_executed_hook(self):
        self.debug_stream("In always_excuted_hook()")
        # - PROTECTED REGION ID(KepcoBOP.always_executed_hook) ENABLED START -#
        # ----- PROTECTED REGION END -----#  //  KepcoBOP.always_executed_hook

    # -------------------------------------------------------------------------
    #    KepcoBOP read/write attribute methods
    # -------------------------------------------------------------------------

    def read_Current(self, attr):
        self.debug_stream("In read_Current()")
        # ----- PROTECTED REGION ID(KepcoBOP.Current_read) ENABLED START -----#
        cmd = ':MEAS:CURR?'
        curr = self.communicate(cmd, True)
        self.attr_Current_read = float(curr)
        attr.set_value(self.attr_Current_read)
        # ----- PROTECTED REGION END -----#  //  KepcoBOP.Current_read

    def read_CurrentSetpoint(self, attr):
        self.debug_stream("In read_CurrentSetpoint()")
        # - PROTECTED REGION ID(KepcoBOP.CurrentSetpoint_read) ENABLED START -#
        curr = self.communicate(':CURR?', True)
        self.attr_CurrentSetpoint_read = float(curr)
        attr.set_value(self.attr_CurrentSetpoint_read)
        # ----- PROTECTED REGION END -----#  //  KepcoBOP.CurrentSetpoint_read

    def write_CurrentSetpoint(self, attr):
        self.debug_stream("In write_CurrentSetpoint()")
        data = attr.get_write_value()
        # - PROTECTED REGION ID(KepcoBOP.CurrentSetpoint_write) ENABLED START-#
        self.communicate('CURR %f' % data)
        # -- PROTECTED REGION END -----#      //KepcoBOP.CurrentSetpoint_write

    def read_FlowControl(self, attr):
        self.debug_stream("In read_FlowControl()")
        # - PROTECTED REGION ID(KepcoBOP.FlowControl_read) ENABLED START -#
        flow_control = self.communicate(':SYST:COMM:SER:PACE?', True)
        if flow_control == 'NONE':
            self.flow_control = False
        elif flow_control == 'XON':
            self.flow_control = True
        else:
            msg = 'Unexpected flow control value: %s' % str(flow_control)
            self.error_stream(msg)
            PyTango.Except.throw_exception(
                'Unexpected value',
                msg,
                '%s::read_FlowControl()' % self.__class__.__name__)
        attr.set_value(self.flow_control)
        # ----- PROTECTED REGION END -----#      //KepcoBOP.FlowControl_read

    def write_FlowControl(self, attr):
        self.debug_stream("In write_FlowControl()")
        data = attr.get_write_value()
        # - PROTECTED REGION ID(KepcoBOP.FlowControl_write) ENABLED START -#
        if data:
            flow_control = 'XON'
        else:
            flow_control = 'NONE'
        self.communicate(':SYST:COMM:SER:PACE %s' % flow_control)
        # ----- PROTECTED REGION END -----#      //KepcoBOP.FlowControl_write

    def read_Mode(self, attr):
        self.debug_stream("In read_Mode()")
        # ----- PROTECTED REGION ID(KepcoBOP.Mode_read) ENABLED START -----#
        mode = self.communicate(':FUNC:MODE?', True)
        if mode in list(self.MODES.keys()):
            self.attr_Mode_read = self.MODES[mode]
        else:
            msg = 'Unexpected mode read from hardware: %s (expected in %s)' %\
                  (str(mode), list(self.MODES.keys()))
            self.error_stream(msg)
            PyTango.Except.throw_exception(
                'Unexpected value',
                msg,
                '%s::read_FlowControl()' % self.__class__.__name__)
        attr.set_value(self.attr_Mode_read)
        # ----- PROTECTED REGION END -----#      //      KepcoBOP.Mode_read

    def write_Mode(self, attr):
        self.debug_stream("In write_Mode()")
        data = attr.get_write_value()
        # ----- PROTECTED REGION ID(KepcoBOP.Mode_write) ENABLED START -----#
        if data not in list(self.MODES.values()):
            msg = '%s is not one of the valid modes (%s)' %\
                  (str(data), str(list(self.MODES.values())))
            PyTango.Except.throw_exception(
                'Invalid parameter',
                msg,
                '%s::write_Mode()' % self.__class__.__name__)
        self.communicate(':FUNC:MODE %s' % data)
        # ----- PROTECTED REGION END -----#      //      KepcoBOP.Mode_write

    def read_Remote(self, attr):
        self.debug_stream("In read_Remote()")
        # ----- PROTECTED REGION ID(KepcoBOP.Remote_read) ENABLED START -----#
        cmd = ':SYST:REM?'
        remote = int(self.communicate(cmd, True))
        self.attr_Remote_read = bool(remote)
        attr.set_value(self.attr_Remote_read)
        self.communicate(cmd, True)
        # ----- PROTECTED REGION END -----#  //  KepcoBOP.Remote_read

    def write_Remote(self, attr):
        self.debug_stream("In write_Remote()")
        data = attr.get_write_value()
        # ----- PROTECTED REGION ID(KepcoBOP.Remote_write) ENABLED START -----#
        cmd = ':SYST:REM %d' % data
        self.communicate(cmd)
        # ----- PROTECTED REGION END -----#  //  KepcoBOP.Remote_write

    def read_Voltage(self, attr):
        self.debug_stream("In read_Voltage()")
        # ----- PROTECTED REGION ID(KepcoBOP.Voltage_read) ENABLED START -----#
        cmd = ':MEAS:VOLT?'
        volt = self.communicate(cmd, True)
        self.attr_Voltage_read = float(volt)
        attr.set_value(self.attr_Voltage_read)
        # ----- PROTECTED REGION END -----#  //  KepcoBOP.Voltage_read

    def read_VoltageSetpoint(self, attr):
        self.debug_stream("In read_VoltageSetpoint()")
        # - PROTECTED REGION ID(KepcoBOP.VoltageSetpoint_read) ENABLED START -#
        volt = self.communicate(':VOLT?', True)
        self.attr_VoltageSetpoint_read = float(volt)
        attr.set_value(self.attr_VoltageSetpoint_read)
        # ----- PROTECTED REGION END -----#  //  KepcoBOP.VoltageSetpoint_read

    def write_VoltageSetpoint(self, attr):
        self.debug_stream("In write_VoltageSetpoint()")
        data = attr.get_write_value()
        # - PROTECTED REGION ID(KepcoBOP.VoltageSetpoint_write) ENABLED START-#
        self.communicate('VOLT %f' % data)
        # ----- PROTECTED REGION END -----#    //KepcoBOP.VoltageSetpoint_write

    def read_Output(self, attr):
        self.debug_stream("In read_Output()")
        # ----- PROTECTED REGION ID(KepcoBOP.Output_read) ENABLED START -----#
        output = bool(int(self.communicate(':OUTP?', True)))
        attr.set_value(output)
        # ----- PROTECTED REGION END -----#      //      KepcoBOP.Output_read

    def write_Output(self, attr):
        self.debug_stream("In write_Output()")
        data = attr.get_write_value()
        # ----- PROTECTED REGION ID(KepcoBOP.Output_write) ENABLED START -----#
        self.communicate(':OUTP %s' % str(int(data)))
        if data:
            state_ = PyTango.DevState.ON
        else:
            state_ = PyTango.DevState.OFF
        self._set_state(state_)
        # ----- PROTECTED REGION END -----#      //      KepcoBOP.Output_write

    def read_attr_hardware(self, data):
        self.debug_stream("In read_attr_hardware()")
        # -- PROTECTED REGION ID(KepcoBOP.read_attr_hardware) ENABLED START --#
        # -- PROTECTED REGION END -----#  //  KepcoBOP.read_attr_hardware

    # -------------------------------------------------------------------------
    #    KepcoBOP command methods
    # -------------------------------------------------------------------------

    def CMD(self, argin):
        """ Send the input parameter as received to the PS supply and return
        read back string from PS (if any)
        :param argin:
        :type argin: PyTango.DevString
        :rtype: PyTango.DevString
        """
        self.debug_stream("In CMD()")
        argout = ""
        # ----- PROTECTED REGION ID(KepcoBOP.CMD) ENABLED START -----#
        argout = self.communicate(argin, True)
        # ----- PROTECTED REGION END -----#  //  KepcoBOP.CMD
        return argout

    # --- PROTECTED REGION ID(KepcoBOP.programmer_methods) ENABLED START -----#

    # ----- PROTECTED REGION END -----#	//	KepcoBOP.programmer_methods


class KepcoBOPClass(PyTango.DeviceClass):
    # -------- Add you global class variables here --------------------------
    # - PROTECTED REGION ID(KepcoBOP.global_class_variables) ENABLED START ---#

    # ----- PROTECTED REGION END -----#  //  KepcoBOP.global_class_variable

    #    Class Properties
    class_property_list = {
        }

    #    Device Properties
    device_property_list = {
        'SerialDevice': [
            PyTango.DevString,
            'The serial device to connect to. Two types are supported:\n'
            '    1) Name of the serial tango device to connect to. Serial and'
            'PySerial devices are supported\n'
            '    2) Name of the serial device to connect (e.g. /dev/ttyS0). In'
            ' this case the connection is direct and this server must be run '
            'on the machine where the serial port resides',
            []],
        'MaxRetries': [
            PyTango.DevVarLongArray,
            'Sometimes the instruments seems to get saturated and will not '
            'respond to some request: if you instrument is giving these kind '
            'of transient errors you can set how many retries you will allow '
            'before going to FAULT state',
            [0]],
        }

    #    Command definitions
    cmd_list = {
        'CMD': [[PyTango.DevString, "none"], [PyTango.DevString, "none"]],
    }

    #    Attribute definitions
    attr_list = {
        'Current':
            [[PyTango.DevDouble,
             PyTango.SCALAR,
             PyTango.READ]],
        'CurrentSetpoint':
            [[PyTango.DevDouble,
             PyTango.SCALAR,
             PyTango.READ_WRITE]],
        'FlowControl':
            [[PyTango.DevBoolean,
             PyTango.SCALAR,
             PyTango.READ_WRITE]],
        'Mode':
            [[PyTango.DevString,
             PyTango.SCALAR,
             PyTango.READ_WRITE],
             {
                'Memorized': 'true'
             }],
        'Remote':
            [[PyTango.DevBoolean,
             PyTango.SCALAR,
             PyTango.READ_WRITE]],
        'Voltage':
            [[PyTango.DevDouble,
             PyTango.SCALAR,
             PyTango.READ]],
        'VoltageSetpoint':
            [[PyTango.DevDouble,
             PyTango.SCALAR,
             PyTango.READ_WRITE]],
        'Output':
            [[PyTango.DevBoolean,
             PyTango.SCALAR,
             PyTango.READ_WRITE]],
        }


def main():
    try:
        py = PyTango.Util(sys.argv)
        py.add_class(KepcoBOPClass, KepcoBOP, 'KepcoBOP')
        # ----- PROTECTED REGION ID(KepcoBOP.add_classes) ENABLED START -----#

        # ----- PROTECTED REGION END -----#	//	KepcoBOP.add_classes

        U = PyTango.Util.instance()
        U.server_init()
        U.server_run()

    except PyTango.DevFailed as e:
        print('-------> Received a DevFailed exception:', e)
    except Exception as e:
        print('-------> An unforeseen exception occured....', e)


if __name__ == '__main__':
    main()
